/*----------------------------------------------------------------------
|       includes
+---------------------------------------------------------------------*/
#ifndef STRICT
#define STRICT
#endif

#include "stdafx.h"

#include "registry.h"

/*----------------------------------------------------------------------
| OpenPocketTVKey
+---------------------------------------------------------------------*/
LONG
OpenPocketTVKey(HKEY *pKey)
{
	return RegOpenKeyEx(HKEY_CURRENT_USER, TEXT("Software\\MpegTV\\PocketTV"), 0, 0, pKey);
}

/*----------------------------------------------------------------------
| SetRegistryValue
+---------------------------------------------------------------------*/
LONG
SetRegistryValue(const TCHAR *pValue, DWORD type, const BYTE *ptr, DWORD size)
{
	HKEY key;
	LONG ret;

	ret = OpenPocketTVKey(&key);
	if (ret != ERROR_SUCCESS) {
		return ret;
	}
	ret = RegSetValueEx(key, pValue, 0, type, ptr, size);
	RegCloseKey(key);
	return ret;
}

/*----------------------------------------------------------------------
| GetRegistryValue
+---------------------------------------------------------------------*/
LONG
GetRegistryValue(const TCHAR *pValue, DWORD type, BYTE *ptr, DWORD *pSize)
{
	HKEY key;
	LONG ret;
	DWORD actual_type;

	ret = OpenPocketTVKey(&key);
	if (ret != ERROR_SUCCESS) {
		return ret;
	}
	ret = RegQueryValueEx(key, pValue, 0, (LPDWORD)&actual_type, ptr, pSize);
	RegCloseKey(key);
	if (ret == ERROR_SUCCESS) {
		if (type == actual_type) {
			return ERROR_SUCCESS;
		} else {
			return -1;
		}
	}
	return ret;
}

/*----------------------------------------------------------------------
| SetRegistryValueDWORD
+---------------------------------------------------------------------*/
LONG
SetRegistryValueDWORD(const TCHAR *pValue, DWORD value)
{
	return SetRegistryValue(pValue, REG_DWORD, (const BYTE *)&value, sizeof value);
}

/*----------------------------------------------------------------------
| GetRegistryValueDWORD
+---------------------------------------------------------------------*/
LONG
GetRegistryValueDWORD(const TCHAR *pValue, DWORD *p)
{
	DWORD size = sizeof(DWORD);

	return GetRegistryValue(pValue, REG_DWORD, (BYTE *)p, &size);
}

// eof