/*----------------------------------------------------------------------
|       includes
+---------------------------------------------------------------------*/
#ifndef STRICT
#define STRICT
#endif

#include "stdafx.h"

#include <commdlg.h>
#include <tchar.h>
#include <winnls.h>

#include "utils.h"

#ifdef SPI_SETSIPINFO

/*----------------------------------------------------------------------
| HideSip
+---------------------------------------------------------------------*/
BOOL
HideSip( void )
{   
    BOOL fRes = FALSE;
    SIPINFO si;
    memset( &si, 0, sizeof( si ) );
    si.cbSize = sizeof( si );
    if( SHSipInfo( SPI_GETSIPINFO, 0, &si, 0 ) )
    {
        si.fdwFlags &= ~SIPF_ON;
        fRes = SHSipInfo( SPI_SETSIPINFO, 0, &si, 0 );
    }    
    return fRes;
}

/*----------------------------------------------------------------------
| ShowSip
+---------------------------------------------------------------------*/
BOOL
ShowSip( void )
{   
    BOOL fRes = FALSE;
    SIPINFO si;
    memset( &si, 0, sizeof( si ) );
    si.cbSize = sizeof( si );
    if( SHSipInfo( SPI_GETSIPINFO, 0, &si, 0 ) )
    {
        si.fdwFlags |= SIPF_ON;
        fRes = SHSipInfo( SPI_SETSIPINFO, 0, &si, 0 );
    }    
    return fRes;
}

#endif

#if defined(UNDER_CE) && (UNDER_CE >= 212)
/*--------------------------------------------------------------------------+
| SetNavBarText
+--------------------------------------------------------------------------*/
int
SetNavBarText(HWND hWnd, const TCHAR *str)
{
	if (str == NULL) {
		TCHAR buf[30];

		GetWindowText(hWnd, buf, sizeof(buf)/sizeof(buf[0]));
		return SHSetNavBarText(hWnd, buf);
	} else {
		return SHSetNavBarText(hWnd, str);
	}
}
#endif


/*--------------------------------------------------------------------------+
| MyLoadString
+--------------------------------------------------------------------------*/
const TCHAR *
MyLoadString(HINSTANCE instance, int id)
{
	unsigned int n;
	TCHAR *q;
	const TCHAR *p = (const TCHAR *)LoadString(instance, id, 0, 0);
	if (p == NULL) {
		return NULL;
	}
	n = *((WORD *)p - 1);
	q = (TCHAR *)malloc((n + 1) * sizeof(TCHAR));
	if (q == NULL) {
		return NULL;
	}
	LoadString(instance, id, q, n + 1);
//	q[n] = 0;
	return q;
}

/*--------------------------------------------------------------------------+
| MyFreeString
+--------------------------------------------------------------------------*/
void
MyFreeString(const TCHAR *str)
{
	if (str != NULL) {
		free((void *)str);
	}
}
